import apiFetch from '@wordpress/api-fetch';
import { useEffect, useState, useCallback ,useMemo,useRef} from '@wordpress/element';
import { SelectControl, TextareaControl } from '@wordpress/components';
import { __ } from '@wordpress/i18n';
import { useSelect, useDispatch } from '@wordpress/data';
import { debounce, multiply } from 'lodash';
import { getSetting } from '@woocommerce/settings';
import Select from 'react-select'
export const Block = ({ checkoutExtensionData }) => {


    useEffect(() => {
      
        setTimeout(() => {
            sort_shipping_feilds(); 
            sort_billing_fields();
        }, 3000);
    }, []);
    


    function sort_shipping_feilds() {
        if (af_const_checkout_shipp_data!=='not_found') {
    var transformedShippingFieldsArray = shippingFieldsArray.map(function(fieldId) {
       return fieldId.replace('_', '-');
    });
    
    // Selector for the parent container holding the fields
    var shippingContainer = jQuery('#shipping');  
    
    transformedShippingFieldsArray.forEach(function(fieldId, index) {
       
       var fieldSelector;
    
       if (fieldId === 'shipping-state' || fieldId === 'shipping-country') {
           fieldSelector = jQuery('#' + fieldId); 
       } else {
           fieldSelector = jQuery('#' + fieldId).closest('div.wc-block-components-text-input');
       }
       
       if (index === 0) {
           fieldSelector.css('margin-top', '16px');
       }
    
       jQuery('#shipping-country').css({
           'margin-top': '16px',
           'width': '100%'
       });
       
       shippingContainer.append(fieldSelector);
    });
    
    
       // Explicitly move the 'shipping-phone' field to the last position
       var phoneFieldSelector = jQuery('#shipping-phone').closest('div.wc-block-components-text-input');
       shippingContainer.append(phoneFieldSelector);
    }
       }

       function sort_billing_fields() {
        if (af_const_checkout_billing_data!=='not_found') {
        // Remove the specified div with class "wc-block-components-text-input"
        var transformedBillingFieldsArray = billingFieldsArray.map(function(fieldId) {
            return fieldId.replace('_', '-');
        });
    
        // Selector for the parent container holding the fields
        var billingContainer = jQuery('#billing');
    
        transformedBillingFieldsArray.forEach(function(fieldId, index) {
            var fieldSelector;
    
            if (fieldId === 'billing-state' || fieldId === 'billing-country') {
                fieldSelector = jQuery('#' + fieldId);
            } else {
                fieldSelector = jQuery('#' + fieldId).closest('div.wc-block-components-text-input');
            }
    
            if (index === 0) {
                fieldSelector.css('margin-top', '16px');
            }
    
            jQuery('#billing-country').css({
                'margin-top': '16px',
                'width': '100%'
            });
    
            billingContainer.append(fieldSelector);
        });
    
        // Explicitly move the 'billing-phone' field to the last position
        // var phoneFieldSelector = jQuery('#billing-phone').closest('div.wc-block-components-text-input');
        // billingContainer.append(phoneFieldSelector);
    }
    }
    
    



    

const [isReCaptchaValid, setIsReCaptchaValid] = useState(false);
    
    
const checkoutFieldsForBlock =  afcf_php_vars.checkout_feilds;




jQuery('.wc-block-components-checkout-place-order-button').click(function(event) {

    checkoutFieldsForBlock.forEach(field => {
        
            const itemkey= field.key;
            setExtensionData('af_ch_f_m_fields_manger', itemkey, '');

if(field._type === 'googlecaptcha'){

    setExtensionData('af_ch_f_m_fields_manger',field.key,grecaptcha.getResponse());

}


            if(field._type ==='text'||field._type ==='vat'||field._type ==='email'||field._type ==='number'){

               if (field._required=='on') {       
                if(jQuery('#'+field.key).val()==''){

                    jQuery('#'+field.key).closest('.wc-block-components-text-input').addClass('has-error');
                 
                    jQuery('#'+field.key+'_validation_error').show();
               
                }else{
                    jQuery('#'+field.key).closest('.wc-block-components-text-input').removeClass('has-error');
                   
                    jQuery('#'+field.key+'_validation_error').hide();
               
                }
            }
            }



            
if(field._type ==='textarea'||field._type ==='password'||field._type ==='datepicker'||field._type ==='timepicker'){
  
   

        
        if (field._required=='on') {       
            if(jQuery('#'+field.key).val()==''){

                jQuery('#'+field.key).closest('.wc-block-components-text-input').addClass('has-error');
                jQuery('#'+field.key).css("border-color","#cf2e2e");
                jQuery('#'+field.key+'_validation_error').show();
           
            }else{
                jQuery('#'+field.key).closest('.wc-block-components-text-input').removeClass('has-error');
                jQuery('#'+field.key).css("border-color","black");
                jQuery('#'+field.key+'_validation_error').hide();
           
            }
        }
}

            if (field._type ==='multi_checkbox'||field._type ==='checkbox'||field._type ==='radio') {

                    if (field._required=='on') {          
                if (!(jQuery('.'+field.key).is(':checked'))) {
                    jQuery('#'+field.key+'_validation_error').show();
                }else{
                    jQuery('#'+field.key+'_validation_error').hide();
                }
            }
            }
            if(field._type ==='privacy'){


                if (!(jQuery('.'+field.key).is(':checked'))) {
                    jQuery('#'+field.key+'_validation_error').show();
                }else{
                    jQuery('#'+field.key+'_validation_error').hide();
                }



            }

            if(field._type ==='multiselect'){
                 
                if (field._required=='on') {  
                        
                if (jQuery('#'+field.key).val()=='') {
                    jQuery('#'+field.key+'_validation_error').show();
                }else{
                    jQuery('#'+field.key+'_validation_error').hide();
                }
            }

            }

            
            


            
        });






});


   useEffect(() => {

    apiFetch({ path: '/wc/store/cart' }).then(posts => {



        var currency_symbol = posts.totals.currency_prefix != '' ? posts.totals.currency_prefix : posts.totals.currency_suffix;
        var currency_symbol_position = posts.totals.currency_prefix != '' ? 'left' : 'right';
        var currency_decimal_seperator = posts.totals.currency_decimal_separator;
        var currency_minor_unit = posts.totals.currency_minor_unit;
    
        checkoutFieldsForBlock.forEach(item => {

            if (item._type === 'multiselect' || item._type === 'multi_checkbox' || item._type === 'radio' || item._type === 'select') {
                Object.values(item._options || {}).forEach(option => {
                    if (option.option_price !== '') {
                        const formattedPrice = parseFloat(option.option_price)
                            .toFixed(currency_minor_unit)
                            .toString()
                            .replace('.', currency_decimal_seperator);
                        option.option_price = currency_symbol_position === 'left' ?
                            `${currency_symbol}${formattedPrice}` :
                            `${formattedPrice}${currency_symbol}`;
                    }
                });
                
            } else {
                // Handle other field types
                if (item.feild_price !== '') {
                    const formattedPrice = parseFloat(item.feild_price).toFixed(currency_minor_unit).toString().replace('.', currency_decimal_seperator);
                    item.feild_price = currency_symbol_position === 'left' ?
                        `${currency_symbol}${formattedPrice}` :
                        `${formattedPrice}${currency_symbol}`;
                }
            }
        });
    });
    

   console.log(checkoutFieldsForBlock);
        checkoutFieldsForBlock.forEach(field => {
        
            const itemkey= field.key;
            setExtensionData('af_ch_f_m_fields_manger', itemkey, '');
//  
            if(field._type ==='text'||field._type ==='vat'||field._type ==='email'||field._type ==='number'){

                if (field.main_class==='half_width') {
                    jQuery('#'+field.key).css("width", "50%");
                }else if(field.main_class==='form-row-wide'){
                    jQuery('#'+field.key).css("width", "100%");
                }


            }



            
if(field._type ==='textarea'||field._type ==='password'||field._type ==='datepicker'||field._type ==='timepicker'){
   
    if (field.main_class==='half_width') {
        jQuery('#'+field.key).css("width", "50%");
    }else if(field.main_class==='form-row-wide'){
        jQuery('#'+field.key).css("width", "100%");
    }
   

}

            if (field._type ==='multi_checkbox'||field._type ==='checkbox'||field._type ==='radio') {
            
            }
            if(field._type ==='privacy'){

           


            }


            if(field._type ==='color'){
                if (field.main_class==='half_width') {
                    jQuery('#'+field.key).css("width", "50%");
                }else if(field.main_class==='form-row-wide'){
                    jQuery('#'+field.key).css("width", "100%");
                }
            }

            if(field._type ==='multiselect'){
              
                if (field.main_class==='half_width') {
                    jQuery('#'+field.key).css("width", "50%");
                }else if(field.main_class==='form-row-wide'){
                    jQuery('#'+field.key).css("width", "100%");
                }


            }

            if(field._css!==''){

                jQuery('#'+field.key).addClass(field._css);

            }
            
           // _block 
            if((field._location_checkout_block=='woocommerce_before_checkout_shipping_form')
            ||(field._location_checkout_block=='woocommerce_before_checkout_billing_form')
            ||(field._location_checkout_block=='woocommerce_after_checkout_shipping_form')
            ||(field._location_checkout_block=='woocommerce_after_checkout_billing_form')
            ||(field._location_checkout_block=='woocommerce_checkout_after_customer_details')
            ||(field._location_checkout_block=='woocommerce_checkout_before_customer_details')
            ||(field._location_checkout_block=='woocommerce_before_order_notes')
            ||(field._location_checkout_block=='woocommerce_review_order_before_submit')
            ){
                
                jQuery('.woocommerce_before_checkout_shipping_form_block').css('marginLeft','37.5px');
                jQuery('.woocommerce_before_checkout_billing_form_block').css('marginLeft','37.5px');
                jQuery('.woocommerce_after_checkout_shipping_form_block').css('marginLeft','37.5px');
                jQuery('.woocommerce_after_checkout_billing_form_block').css('marginLeft','37.5px');
                jQuery('.woocommerce_checkout_after_customer_details_block').css('marginLeft','37.5px');
                jQuery('.woocommerce_checkout_before_customer_details_block').css('marginLeft','37.5px');
                jQuery('.woocommerce_before_order_notes_block').css('marginLeft','37.5px');
                jQuery('.woocommerce_review_order_before_submit_block').css('marginBottom','15px');
                
                
            }
            
        });



    setTimeout(() => {
        // Iterate through each session data item
        if (Array.isArray(afcf_php_vars.af_cf_checkout_block_fee_session) && afcf_php_vars.af_cf_checkout_block_fee_session.length > 0) {
         afcf_php_vars.af_cf_checkout_block_fee_session.forEach(item => {
            const key = item.key;
            const value = item.value;
    
            // Store data for extension processing
            setExtensionData('af_ch_f_m_fields_manger', key, value);
    
            // Find the checkbox input field by its class (assuming the keys are classes for checkboxes)
            const $checkboxes = jQuery('.'+key);
    
            // Handle checkboxes separately
            if ($checkboxes.length) {
                $checkboxes.each(function() {
                    let $checkbox = jQuery(this);

                    // Initialize checkbox state to unchecked
                    $checkbox.prop('checked', false);
    
                    // Determine if the checkbox should be checked
                    if (Array.isArray(value)) {
                        // Check the checkbox if any value in the array matches the checkbox's name attribute
                        value.forEach(val => {
                            if (val === $checkbox.attr('name')) {
                                $checkbox.prop('checked', true);
                            }
                        });
                    } else {
                        // Check the checkbox if its value matches the checkbox's name attribute
                        if (value === $checkbox.attr('name')) {
                            $checkbox.prop('checked', true);
                        }

                        if(value=='true'){
                            $checkbox.prop('checked', true);
                        }
                    }
                });
            }
    
            // For all other input types, continue to use ID for selection
            const $input = jQuery('#' + key);
            if ($input.length && !$input.is('input[type="checkbox"]')) { // Exclude checkboxes already handled
                if ($input.is('select[multiple]')) {
                    // Handle multi-select inputs
                    $input.val(null); // Clear previous selections
                    if (Array.isArray(value)) {
                        value.forEach(val => {
                            $input.find('option[value="' + val + '"]').prop('selected', true);
                        });
                    }
                    
                }else if($input.is('input[type="radio"]')){
                    jQuery('input[name="'+key+'"]').each(function() {
                        if (jQuery(this).val() === value) {    
            
                            setTimeout(() => {
                                jQuery(this).prop('checked',true);
                            }, 100);
                        
                            
                        }
                    });
            
                }else {
                    // Handle other input types (e.g., text)
                    if (Array.isArray(value)) {
                        $input.val(value.join(', ')); // Join array values if it's an array
                    } else {
                        $input.val(value); // Set the value directly if it's a string
                    }
                }
            }
        });
    }
    }, 4000); // Delay of 4 seconds




    hide_feilds();   
  //  sort_shipping_feilds();
    afcm_clear_shipping_validation();
    afcm_clear_billing_validation();
 

    
    setTimeout(() => {

     
        jQuery('.wp-block-af_ch_f_m_fields_manger-tax-exempt').show();

     jQuery('.woocommerce_before_checkout_billing_form_block').insertAfter('.wc-block-checkout__shipping-fields');
     jQuery('.woocommerce_after_checkout_billing_form_block').insertBefore('.wc-block-checkout__shipping-option');
     jQuery('.woocommerce_checkout_before_customer_details_block').insertBefore('.wc-block-checkout__form');
     jQuery('.woocommerce_checkout_after_customer_details_block').insertBefore('.wp-block-woocommerce-checkout-shipping-address-block');
     jQuery('.woocommerce_before_checkout_shipping_form_block').insertBefore('.wp-block-woocommerce-checkout-shipping-address-block');
     jQuery('.woocommerce_after_checkout_shipping_form_block').insertAfter('.wp-block-woocommerce-checkout-shipping-address-block');
     jQuery('.woocommerce_checkout_before_order_review_heading_block').insertBefore('.wc-block-components-order-summary');
     jQuery('.woocommerce_checkout_before_order_review_block').insertBefore('.wc-block-components-panel__content');
     jQuery('.woocommerce_checkout_after_order_review_block').insertAfter('.wp-block-woocommerce-checkout-actions-block');
     jQuery('.woocommerce_before_order_notes_block').insertBefore('.wc-block-checkout__order-notes');
     jQuery('.woocommerce_after_order_notes_block').insertAfter('.wc-block-checkout__order-notes');
     jQuery('.woocommerce_checkout_before_terms_and_conditions_block').insertBefore('.wp-block-woocommerce-checkout-terms-block');
     jQuery('.woocommerce_checkout_after_terms_and_conditions_block').insertAfter('.wp-block-woocommerce-checkout-terms-block');
     jQuery('.woocommerce_review_order_before_submit_block').insertBefore('.wc-block-checkout__actions_row');
     jQuery('.woocommerce_review_order_after_submit_block').insertAfter('.wc-block-checkout__actions_row');
     jQuery('.new-line').insertAfter('.woocommerce_checkout_before_customer_details_block');
    

     checkoutFieldsForBlock.forEach(field => {

        if(field._css!==''){

            jQuery('#'+field.key).addClass(field._css);

        }
        
    });




    }, 2000);


    checkoutFieldsForBlock.forEach(field => {
                


        if(field.dep_fields!==''){
       //     console.log(field.key)
        jQuery('#'+field.key+'_dependable').insertAfter(field.dep_fields);


        
        setTimeout(() => {
            
            if(jQuery(field.dep_fields).length <1){
                jQuery('#'+field.key+'_dependable').hide();
            }
        }, 5000);
    


        }

         
        

        
    });




    window.onReCaptchaSuccess = () => {
        setExtensionData('af_ch_f_m_fields_manger', 'recaptcha', 'valid');
        setIsReCaptchaValid(true);

    };
    window.onReCaptchaExpired = () => {
        setExtensionData('af_ch_f_m_fields_manger', 'recaptcha', '');
        setIsReCaptchaValid(false);
    };

    const script = document.createElement('script');
    script.src = 'https://www.google.com/recaptcha/api.js';
    script.async = true;
    script.defer = true;
    document.body.appendChild(script);

    // Clean up the script and callbacks to prevent memory leaks
    return () => {
        document.body.removeChild(script);
        delete window.onReCaptchaSuccess;
        delete window.onReCaptchaExpired;
    };

}, []);

    


   // console.log(checkoutFieldsForBlock);

    const af_get_current_user_role= afcf_php_vars.af_cf_crnt_usr_role;

    

    const af_const_checkout_shipp_data= afcf_php_vars.af_checkout_feilds_shiped;

    const af_const_checkout_billing_data= afcf_php_vars.af_checkout_feilds_bill;

    var shippingFieldsArray='';

    if (af_const_checkout_shipp_data !=='not_found') {
        const shippingDataObject = JSON.parse(af_const_checkout_shipp_data);
        shippingFieldsArray = Object.values(shippingDataObject[af_get_current_user_role]);    
   
    }
    var billingFieldsArray='';
    if (af_const_checkout_billing_data !=='not_found') {
    const billingDataObject = JSON.parse(af_const_checkout_billing_data);
          billingFieldsArray = Object.values(billingDataObject[af_get_current_user_role]);
    }
    const google_recapta_site_key_data= afcf_php_vars.google_recapta_site_key;
    const { setExtensionData } = checkoutExtensionData;
    const [inputValues, setInputValues] = useState({});
    const [multiCheckboxValues, setMultiCheckboxValues] = useState({});
    const [typingTimer, setTypingTimer] = useState(null);
    const timeoutIdRef = useRef(null);
    const [clicked, setClicked] = useState(false);
    const { clearValidationError } = useDispatch(
		'wc/store/validation'
	);
   
    // apiFetch({ path: '/wc/store' }).then((posts) => { console.log(posts); });
   // afcm_clear_shipping_validation();


   function afcm_clear_billing_validation() {
    if (af_const_checkout_billing_data!=='not_found') {
    var billing_existing_fields_clear_validation = [
        'billing_first_name',
        'billing_last_name',
        'billing_company',
        'billing_country',
        'billing_address_1',
        'billing_address_2',
        'billing_city',
        'billing_state',
        'billing_postcode'
    ];

    var commonBillingFields_clear_validation = billing_existing_fields_clear_validation.filter(field => billingFieldsArray.includes(field));

    var fieldIds_clear_validation = [];

    if (!commonBillingFields_clear_validation.includes('billing_first_name')) {
        fieldIds_clear_validation.push('billing_first_name');
    } 

    if (!commonBillingFields_clear_validation.includes('billing_last_name')) {
        fieldIds_clear_validation.push('billing_last_name');
    }

    if (!commonBillingFields_clear_validation.includes('billing_company')) {
        fieldIds_clear_validation.push('billing_company');
    }

    if (!commonBillingFields_clear_validation.includes('billing_country')) {
        fieldIds_clear_validation.push('billing_country');
    }
    if (!commonBillingFields_clear_validation.includes('billing_address_1')) {
        fieldIds_clear_validation.push('billing_address_1');
    }
    if (!commonBillingFields_clear_validation.includes('billing_address_2')) {
        fieldIds_clear_validation.push('billing_address_2');
    }
    if (!commonBillingFields_clear_validation.includes('billing_city')) {
        fieldIds_clear_validation.push('billing_city');
    }
    if (!commonBillingFields_clear_validation.includes('billing_state')) {
        fieldIds_clear_validation.push('billing_state');
    }
    if (!commonBillingFields_clear_validation.includes('billing_postcode')) {
        fieldIds_clear_validation.push('billing_postcode');
    }

    setTimeout(() => {
        fieldIds_clear_validation.forEach(function(fieldId_clear_validation) {
            clearValidationError(fieldId_clear_validation);
        });
    }, 2000);
   }
}

function afcm_clear_shipping_validation(){
    
    if (af_const_checkout_shipp_data!=='not_found') {

var shipping_existing_feilds_clear_validation=[
            'shipping_first_name',
            'shipping_last_name',
            'shipping_company',
            'shipping_country',
            'shipping_address_1',
            'shipping_address_2',
            'shipping_city',
            'shipping_state',
            'shipping_postcode'];


var commonShippingFeilds_clear_validation = shipping_existing_feilds_clear_validation.filter(field => shippingFieldsArray.includes(field));


 var fieldIds_clear_validation = [];


 if (!commonShippingFeilds_clear_validation.includes('shipping_first_name')) {
    fieldIds_clear_validation.push('shipping_first_name');
 } 

 if (!commonShippingFeilds_clear_validation.includes('shipping_last_name')) {
    fieldIds_clear_validation.push('shipping_last_name');
 }

 if (!commonShippingFeilds_clear_validation.includes('shipping_company')) {
    fieldIds_clear_validation.push('shipping_company');
}

 if (!commonShippingFeilds_clear_validation.includes('shipping_country')) {
    
    fieldIds_clear_validation.push('shipping_country');
 }
 if (!commonShippingFeilds_clear_validation.includes('shipping_address_1')) {
    fieldIds_clear_validation.push('shipping_address_1');
 }
 if (!commonShippingFeilds_clear_validation.includes('shipping_address_2')) {
    fieldIds_clear_validation.push('shipping_address_2');
 }
 if (!commonShippingFeilds_clear_validation.includes('shipping_city')) {
    fieldIds_clear_validation.push('shipping_city');
 }
 if (!commonShippingFeilds_clear_validation.includes('shipping_state')) {
    fieldIds_clear_validation.push('shipping_state');
 }
 if (!commonShippingFeilds_clear_validation.includes('shipping_postcode')) {
    fieldIds_clear_validation.push('shipping_postcode');
 }

        setTimeout(() => {

            fieldIds_clear_validation.forEach(function(fieldId_clear_validation) {

                clearValidationError(fieldId_clear_validation);
           
            });
        
        }, 2000);
    }
    }



     hide_feilds();

    function hide_feilds() {

        if (af_const_checkout_shipp_data!=='not_found') {
            var shipping_existing_feilds=['shipping_first_name',
                                          'shipping_last_name',
                                          'shipping_company',
                                          'shipping_country',
                                          'shipping_address_1',
                                          'shipping_address_2',
                                          'shipping_city',
                                          'shipping_state',
                                          'shipping_postcode'];

var commonShippingFeilds = shipping_existing_feilds.filter(field => shippingFieldsArray.includes(field));


var shippingfieldIds = [];


     if (!commonShippingFeilds.includes('shipping_first_name')) {
        shippingfieldIds.push('#shipping-first_name');
     } 

     if (!commonShippingFeilds.includes('shipping_last_name')) {
        shippingfieldIds.push('#shipping-last_name');
     }

    //  if (!commonShippingFeilds.includes('shipping_company')) {

    //  }

     if (!commonShippingFeilds.includes('shipping_country')) {
        shippingfieldIds.push('#shipping-country');
     }
     if (!commonShippingFeilds.includes('shipping_address_1')) {
        shippingfieldIds.push('#shipping-address_1');
     }
     if (!commonShippingFeilds.includes('shipping_address_2')) {
        shippingfieldIds.push('#shipping-address_2');
     }
     if (!commonShippingFeilds.includes('shipping_city')) {
        shippingfieldIds.push('#shipping-city');
     }
     if (!commonShippingFeilds.includes('shipping_state')) {
        shippingfieldIds.push('#shipping-state');
     }
     if (!commonShippingFeilds.includes('shipping_postcode')) {
        shippingfieldIds.push('#shipping-postcode');
     }

     shippingfieldIds.forEach(function(fieldId) {
                // Remove attributes
             jQuery(fieldId).prop('required', false);
             jQuery(fieldId).removeAttr('autocapitalize autocomplete aria-label aria-invalid title value');
             jQuery(fieldId).closest('.wc-block-components-text-input').hide();
             jQuery(fieldId).hide();  
           
        });

    }if (af_const_checkout_billing_data!=='not_found') {

    
        var billing_existing_fields = [
            'billing_first_name',
            'billing_last_name',
            'billing_company',
            'billing_country',
            'billing_address_1',
            'billing_address_2',
            'billing_city',
            'billing_state',
            'billing_postcode'
        ];
        
        var commonBillingFields = billing_existing_fields.filter(field => billingFieldsArray.includes(field));
        
        var billingFieldIds = [];
        
        if (!commonBillingFields.includes('billing_first_name')) {
            billingFieldIds.push('#billing-first_name');
        } 
        
        if (!commonBillingFields.includes('billing_last_name')) {
            billingFieldIds.push('#billing-last_name');
        }
        
        // if (!commonBillingFields.includes('billing_company')) {
        // }
        
        if (!commonBillingFields.includes('billing_country')) {
            billingFieldIds.push('#billing-country');
        }
        if (!commonBillingFields.includes('billing_address_1')) {
            billingFieldIds.push('#billing-address_1');
        }
        if (!commonBillingFields.includes('billing_address_2')) {
            billingFieldIds.push('#billing-address_2');
        }
        if (!commonBillingFields.includes('billing_city')) {
            billingFieldIds.push('#billing-city');
        }
        if (!commonBillingFields.includes('billing_state')) {
            billingFieldIds.push('#billing-state');
        }
        if (!commonBillingFields.includes('billing_postcode')) {
            billingFieldIds.push('#billing-postcode');
        }
        
        billingFieldIds.forEach(function(fieldId) {
            // Remove attributes
            jQuery(fieldId).prop('required', false);
            jQuery(fieldId).removeAttr('autocapitalize autocomplete aria-label aria-invalid title value');
            jQuery(fieldId).closest('.wc-block-components-text-input').hide();
            jQuery(fieldId).hide();  
        });
        
    }
   
    }
    
    

    jQuery(document).ready(function($) {

        

        jQuery('.wc-block-components-checkbox__label').click(function() {

            setTimeout(() => {

                sort_billing_fields();    
            
            }, 100);

        });

        jQuery('.wc-block-checkout__use-address-for-billing').click(function name() {

            setTimeout(() => {

                sort_billing_fields();    
            
            }, 100);
            
        })


        jQuery('.wc-block-components-checkbox__input').click(function() {
            // Call the sort_billing_fields function

            setTimeout(() => {

                sort_billing_fields();    
            
            }, 100);

        });


   

        jQuery(".wc-block-components-checkout-place-order-button").on("click", function() {

            sort_shipping_feilds();        
            afcm_clear_shipping_validation();
            afcm_clear_billing_validation();

        });
        
        jQuery(".wc-block-components-address-card__edit").on("click", function() {
            
            sort_shipping_feilds();
            hide_feilds();
 
        });
    });



function setCookie(name, value, years) {
    var expiryDate = new Date();
    expiryDate.setFullYear(expiryDate.getFullYear() + years);
    Cookies.set(name, value, { expires: expiryDate });
}



const DEBOUNCE_DELAY = 500; 

useEffect(() => {
    let typingTimer;

    const prepareDataForAjax = () => {

        const dataToBeSent = [];

        checkoutFieldsForBlock.forEach(field => {
            if (field._type === 'multi_checkbox' && multiCheckboxValues[field.key]) {
                const checkedValues = Object.keys(multiCheckboxValues[field.key])
                    .filter(key => multiCheckboxValues[field.key][key]);

                const oldCheckedValues = afcf_php_vars.af_cf_checkout_block_fee_session.find(item => item.key === field.key)?.value || [];
                const uncheckedValues = Object.keys(multiCheckboxValues[field.key])
                    .filter(key => multiCheckboxValues[field.key][key] === false);

                let mergedArray = [...new Set([...checkedValues, ...oldCheckedValues])];
                let filteredArray = mergedArray.filter(value => !uncheckedValues.includes(value));

                setExtensionData('af_ch_f_m_fields_manger', field.key, filteredArray);
                dataToBeSent.push({ key: field.key, value: filteredArray });
                
            } else if (inputValues[field.key] !== undefined && inputValues[field.key] !== null) {
                setExtensionData('af_ch_f_m_fields_manger', field.key, inputValues[field.key]);
                dataToBeSent.push({ key: field.key, value: inputValues[field.key] });
                
            }
        });

        if (dataToBeSent.length > 0) {
            jQuery.ajax({
                type: 'POST',
                url: afcf_php_vars.admin_url,
                data: {
                    action: 'checkout_feild_manager_cookie_block_fee',
                    af_checkout_feild_manager_extension_data: dataToBeSent,
                    nonce: afcf_php_vars.nonce,
                },
                success: function (response) {
                    response.data.checkout_block_fee_session.forEach(item => {
                        setExtensionData('af_ch_f_m_fields_manger', item.key, item.value);
                    });
                },
                error: function (error) {
                    console.error('AJAX call failed:', error);
                }
            });
        }
    };

    if (typingTimer) {
        clearTimeout(typingTimer);
    }

    typingTimer = setTimeout(() => {
        prepareDataForAjax();
    }, DEBOUNCE_DELAY);

    return () => clearTimeout(typingTimer);
}, [inputValues, multiCheckboxValues, checkoutFieldsForBlock, setExtensionData]);



const handleClick = () => {
    setClicked(true);
};

const handleMouseOut = () => {
    if (clicked) {
        jQuery('.af_ch_f_m_loading_message').addClass('show');
        if (timeoutIdRef.current) {
            clearTimeout(timeoutIdRef.current);
        }

        timeoutIdRef.current = setTimeout(() => {
            setClicked(false);
            reloadPageContent();
        }, 1200);
    }

    
};


const handleMultiCheckboxChange = (fieldKey, optionValue, e) => {
    
    setMultiCheckboxValues(prevState => {
        const updatedCheckboxes = {
            ...prevState[fieldKey],
            [optionValue]: e.target.checked
        };
        
        setExtensionData('af_ch_f_m_fields_manger', fieldKey, Object.keys(updatedCheckboxes).filter(key => updatedCheckboxes[key]));

        return {
            ...prevState,
            [fieldKey]: updatedCheckboxes
        };
    });
  


};


    
    const handleTextareaInputChange = (e) => {
        const { id, value } = e.target;
        setInputValues(prev => ({
            ...prev,
            [id]: value
        }));
        if(value!==''){
            jQuery('#'+id).closest('.wc-block-components-text-input').removeClass('has-error');
            jQuery('#'+id).css("border-color","black");
            jQuery('#'+id+'_validation_error').hide();
        
        }else{
            
            jQuery('#'+id).closest('.wc-block-components-text-input').addClass('has-error');
            jQuery('#'+id).css("border-color","#cf2e2e");
            jQuery('#'+id+'_validation_error').show();
        }

    };



    const handleInputChange = (e) => {
        const { id, value } = e.target;
        setInputValues(prev => ({
            ...prev,
            [id]: value
        }));
        if(value!==''){
            jQuery('#'+id).closest('.wc-block-components-text-input').removeClass('has-error');
          //  jQuery('#'+id).closest('.wc-block-components-text-input').css("border-color","#cf2e2e");
            jQuery('#'+id+'_validation_error').hide();
        
        }else{
            
            jQuery('#'+id).closest('.wc-block-components-text-input').addClass('has-error');
               
            jQuery('#'+id+'_validation_error').show();
        }

    };


    const handleRadioChange = (e) => {
        const { id, value } = e.target;
        setInputValues(prevState => ({
            ...prevState,
            [id]: value
        }));

    };


    const handleDatePickerChange = (e) => {
        const { id, value } = e.target;
        setInputValues(prevState => ({
            ...prevState,
            [id]: value
        }));

        if(value!==''){
            jQuery('#'+id).closest('.wc-block-components-text-input').removeClass('has-error');
            jQuery('#'+id).css("border-color","black");
            jQuery('#'+id+'_validation_error').hide();
        
        }else{
            
            jQuery('#'+id).closest('.wc-block-components-text-input').addClass('has-error');
            jQuery('#'+id).css("border-color","#cf2e2e");
            jQuery('#'+id+'_validation_error').show();
        }
    };


    const handleMultiselectChange = (e) => {
        const { id, options } = e.target;
        const selectedOptions = Array.from(options)
            .filter(option => option.selected)
            .map(option => option.value);
        setInputValues(prevState => ({
            ...prevState,
            [id]: selectedOptions
        }));

   
    };

    

    const handleFileUpload = (e) => {
        const { id, files } = e.target;

      setTimeout(() => {

        reloadPageContent(); 
    
    }, 230);
    
    };

    const handleCheckboxChange = (e) => {
        const { id, checked } = e.target;
        setInputValues(prevState => ({
            ...prevState,
            [id]: checked
            
        }));
    };




    const handlePrivacyTextChange = (e) => {
        const { id, checked } = e.target;
        setInputValues(prevState => ({
            ...prevState,
            [id]: checked
            
        }));

    };




    
    const handleNumberChange = (e) => {
        const { id, value } = e.target;
        setInputValues(prevState => ({
            ...prevState,
            [id]: value
        }));
        if(value!==''){
            jQuery('#'+id).closest('.wc-block-components-text-input').removeClass('has-error');
               
            jQuery('#'+id+'_validation_error').hide();
        
        }else{
            
            jQuery('#'+id).closest('.wc-block-components-text-input').addClass('has-error');
               
            jQuery('#'+id+'_validation_error').show();
        }
        
    };

    // Function to handle time picker changes
    const handleTimePickerChange = (e) => {
        const { id, value } = e.target;
        setInputValues(prevState => ({
            ...prevState,
            [id]: value
        }));
        if(value!==''){
            jQuery('#'+id).closest('.wc-block-components-text-input').removeClass('has-error');
            jQuery('#'+id).css("border-color","black");
            jQuery('#'+id+'_validation_error').hide();
        
        }else{
            
            jQuery('#'+id).closest('.wc-block-components-text-input').addClass('has-error');
            jQuery('#'+id).css("border-color","#cf2e2e");
            jQuery('#'+id+'_validation_error').show();
        }

    };

    const handleBlur = () => {
    
        jQuery('.af_ch_f_m_loading_message').addClass('show');
        setTimeout(() => {

            reloadPageContent(); 
        
        }, 1000);

    };

// Function to handle password changes
const handlePasswordChange = (e) => {
    const { id, value } = e.target;
    setInputValues(prevState => ({
        ...prevState,
        [id]: value
    }));
    if(value!==''){
        jQuery('#'+id).closest('.wc-block-components-text-input').removeClass('has-error');
        jQuery('#'+id).css("border-color","black");
        jQuery('#'+id+'_validation_error').hide();
    
    }else{
        
        jQuery('#'+id).closest('.wc-block-components-text-input').addClass('has-error');
        jQuery('#'+id).css("border-color","#cf2e2e");
        jQuery('#'+id+'_validation_error').show();
    }
};

  // Function to handle color picker changes
  const handleColorPickerChange = (e) => {
    const { id, value } = e.target;
    setInputValues(prevState => ({
        ...prevState,
        [id]: value
    }));
    
    };    

   hide_feilds();


   //content refresh logic
   function reloadPageContent() {
    if (sessionStorage.getItem('contentLoaded') === 'true') {
        return;
    }
    
    jQuery.ajax({
        url: window.location.href,
        cache: false,
        success: function (response) {
            jQuery('#content').html(response);
            hideDuplicateElements('.site-header');
            hideDuplicateElements('.storefront-breadcrumb');
            hideDuplicateElements('.site-footer');
            sessionStorage.setItem('contentLoaded', 'true');  // Set a flag indicating the content has been loaded

            setTimeout(() => {
                sessionStorage.setItem('contentLoaded', 'false');
            }, 5000); // 5000 milliseconds = 5 seconds
            
            
        },
        error: function (xhr, status, error) {
            console.error("Error during AJAX request:", status, error);
        }
    });
    setTimeout(() => {
        jQuery('.af_ch_f_m_loading_message').removeClass('show');
        // jQuery('.af_ch_f_m_loading_message').hide();
    }, 3000); // 5000 milliseconds = 5 seconds
 

    }   

   function hideDuplicateElements(selector) {
    var elements = jQuery(selector);
    if (elements.length > 1) {
        elements.last().hide();
    }
   }
    
    return (
        <div className="wc-block-components-checkout-step wc-block-components-checkout-step--with-step-number wp-block-af_ch_f_m_fields_manger-tax-exempt" style={{ display: 'none' }}>
            {checkoutFieldsForBlock.map(field => (
                <div key={field.key}>
                       {field.Is_feild_to_display === '_feild_included' && (
                        <>
                    {field._type === 'text' && (                    
                    <>
                
<div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
    
    <div className='wc-block-components-text-input is-active'>
    <input 
        type='text' 
        id={field.key} 
        placeholder={field._placeholder} 
        value={inputValues[field.key]} 
        onChange={handleInputChange} 
        onBlur={handleBlur}
        aria-invalid="false"
    />
    
   {/* <label for={field.key}>{`${field.feild_title} (${field.feild_price})`}</label> */}
   <label for={field.key}>
  {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
</label>

    </div>
     
    <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
    </div>
</>
                       
)}
    {field._type === 'vat' && (
               <>
               <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
              
                <div className='wc-block-components-text-input is-active'>
                        <input 
                        type='text' 
                        id={field.key}
                        placeholder={field._placeholder}  
                        value={inputValues[field.key]} 
                        onChange={handleInputChange}
                        onBlur={handleBlur}
                        aria-invalid="false"
                        />
                           <label for={field.key}>
  {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
</label>
                        </div>
                        <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
                        </div>
                        
                    </>
                    
                    )}
                    {field._type === 'select' && (
                        <>
                        
                        <div className={`${field._location_checkout_block}_block`}  id={`${field.key}_dependable`}> 
                        
                        <div className='wc-block-components-text-input is-active'
                        
                           
                   style={{
                    backgroundColor:'#fff',
                    border:'1px solid hsla(0,0%,7%,.8)',
                    borderRadius:'4px',
                    boxSizing:'border-box',
                    color:'#2b2d2f',
                    fontFamily:'inherit',
                    fontSize:'1em',
                    lineHeight:'1em',
                    margin:'0',
                    minHeight:'0',
                    padding:'1.5em 0 .5em',
                    width:'100%',
                    marginTop:'15px',
                   }}

                        >
                        <select 
                        id={field.key} 
                        value={inputValues[field.key]} 
                         onChange={handleInputChange}
                         onBlur={handleBlur}
                                   
                   style={{
                    backgroundColor:'#fff',
                    border:'#fff',
                    color:'#2b2d2f',
                    fontFamily:'inherit',
                    fontSize:'1em',
                    width:'100%',
                    paddingLeft:'5px',

                   }}
                   
                  >
                            {Object.entries(field._options).map(([key, option]) => ( 
                                <option style={{  color:'#2b2d2f', fontFamily:'inherit',fontSize:'1em'}}  key={key} value={option.field_value}>{`${option.field_text}${option.option_price ? ` (${option.option_price})` : ''}`}</option>
                            ))}
                        </select>
                        <label >{field.feild_title}</label>
                        </div>
                        </div>
                    </>
                    )}
                    {field._type === 'email' && (
                     <>
                        <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
                        <div className='wc-block-components-text-input is-active'>
                        <input type="email" 
                               id={field.key} 
                               placeholder={field._placeholder}  
                               value={inputValues[field.key]} 
                               onChange={handleInputChange} 
                               onBlur={handleBlur} />
                        <label for={field.key}>
                         {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
                        </label>
                        </div>
                        <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
                        </div>
                      
                    </>
                    
                    )}
              {field._type === 'multiselect' && (
                    <>
                    <div className={`${field._location_checkout_block}_block`}  id={`${field.key}_dependable`}     style={{marginTop:'15px'}} > 
                     <label>{field.feild_title}{field.feild_price}</label>
                   <div className='wc-block-components-combobox-control'>
                   <select 
    id={field.key} 
    multiple 
    value={inputValues[field.key]}  
    onChange={handleMultiselectChange}
    onBlur={handleBlur}
    style={{
        appearance: 'none',
        WebkitAppearance: 'none',
        MozAppearance: 'none',
        backgroundColor: '#fff',
        color: '#333',
        border: '1px solid #ccc',
        padding: '8px 30px 8px 10px',
        borderRadius: '4px'
    }}
>
    {Object.entries(field._options).map(([key, option]) => (
        <option key={key} value={option.field_value}>
            {`${option.field_text}${option.option_price ? ` (${option.option_price})` : ''}`}
        </option>
    ))}
</select>

                        </div>
                        <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>

                        </div>
                    </>
                   
                    )}
                    {field._type === 'fileupload' && (
                            <>
                             <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
                               <label>{field.feild_title}{field.feild_price}</label>
                                 <input type='file' id={field.key} className='input-text af_ch_f_field_fileupload'  onChange={handleFileUpload} />
                            </div>
                            </>
                    
                    )}
                    {field._type === 'privacy' && (
                        <>
                        <div className={`${field._location_checkout_block}_block`}  id={`${field.key}_dependable`}> 
                         <label onClick={handleClick} onMouseOut={handleMouseOut}>
                         <input type='checkbox' 
                         id={field.key} 
                         className={field.key}
                         checked={inputValues[field.key]} 
                         onChange={handlePrivacyTextChange} 
                         onClick={handleClick} onMouseOut={handleMouseOut}/>
                         <span onClick={handleClick} onMouseOut={handleMouseOut} style={{marginLeft:'7px'}}>{field._text}</span>
                          </label>
<div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
                        
                        </div>
                    </>
                    
                    )}
                   {field._type === 'number' && (
                    <>
                    <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
                    
                    <div className='wc-block-components-text-input is-active'>
                    <input
                      type='number'
                      id={field.key}
                      placeholder={field._placeholder}
                      value={inputValues[field.key]}
                      onChange={handleNumberChange}
                      onBlur={handleBlur}
                     />
                        <label for={field.key}>
                         {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
                        </label>
                     </div>
                     <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
                     </div>
                     
                    </>
                    )}
                    {field._type === 'color' && (
                        <>
                        <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
                         <label for={field.key}>
                         {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
                        </label>
                        <div >
                 
                        <input 
                            type='color' 
                            id={field.key} 
                            value={inputValues[field.key]} 
                            onChange={handleColorPickerChange} 
                            onBlur={handleBlur}
                        />
                        
                       
                        </div>
                       </div>
                    </>
                    )}

                {field._type === 'googlecaptcha' && (
            <>
             <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
                   <span class="required">*</span>
                   <label for={field.key}>
                         {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
                        </label>
            <div className="g-recaptcha"   data-sitekey={google_recapta_site_key_data}></div>
            </div>
                    </>
                    
                    )}
                    {field._type === 'datepicker' && (


            <>
            <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
        
            <div className='wc-block-components-text-input is-active'>
            <input type="date" id={field.key} 
             value={inputValues[field.key]} 
             onChange={handleDatePickerChange} 
             onBlur={handleBlur}
             style={{
                backgroundColor:'#fff',
                border:'1px solid hsla(0,0%,7%,.8)',
                borderRadius:'4px',
                boxSizing:'border-box',
                color:'#2b2d2f',
                fontFamily:'inherit',
                fontSize:'1em',
                lineHeight:'1em',
                margin:'0',
                minHeight:'0',
                padding:'1.5em .5em .5em',
                width:'100%',
              }} 
             
             />
              <label for={field.key}>
                         {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
                        </label>
            </div>
   <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
            
            </div>
            </>

                    )}
                    {field._type === 'password' && (
                     <>
                     
                     <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
                     <div className='wc-block-components-text-input is-active'>
                     <input 
                      type='password' 
                      id={field.key} 
                      value={inputValues[field.key]} 
                      onChange={handlePasswordChange} 
                      onBlur={handleBlur}
                      style={{
                        backgroundColor:'#fff',
                        border:'1px solid hsla(0,0%,7%,.8)',
                        borderRadius:'4px',
                        boxSizing:'border-box',
                        color:'#2b2d2f',
                        fontFamily:'inherit',
                        fontSize:'1em',
                        lineHeight:'1em',
                        margin:'0',
                        minHeight:'0',
                        padding:'1.5em .5em .5em',
                        width:'100%',
                      }} 
                      />
                  <label for={field.key}>
                         {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
                        </label>
                      </div>
   <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>

                      </div>
                    </>
     )}
                 
                    {field._type === 'timepicker' && (
               
               
               <>
               <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`} > 
              
               <div >
               <div className='wc-block-components-text-input is-active'>
               <input 
                        type='time' 
                        id={field.key} 
                        value={inputValues[field.key]} 
                        onChange={handleTimePickerChange} 
                        onBlur={handleBlur}
                        style={{
                            backgroundColor:'#fff',
                            border:'1px solid hsla(0,0%,7%,.8)',
                            borderRadius:'4px',
                            boxSizing:'border-box',
                            color:'#2b2d2f',
                            fontFamily:'inherit',
                            fontSize:'1em',
                            lineHeight:'1em',
                            margin:'0',
                            minHeight:'0',
                            padding:'1.5em .5em .5em',
                            width:'100%',
                          }} 
                          />
                           <label for={field.key}>
                         {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
                        </label>
                          </div>
               </div>
               </div>
               </>
               
                    )}

    {field._type === 'multi_checkbox' && (
    <>
    <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`}>
    <label>{field.feild_title}</label>
    {Object.values(field._options || {}).map(option => (
    <label onClick={handleClick} onMouseOut={handleMouseOut} style={{display:'block'}} key={option.field_value}>
        <input
            type="checkbox"
            name={option.field_value}
            id={field.key}
            className={field.key}
            checked={multiCheckboxValues[field.key]?.[option.field_value]}
            onChange={(e) => handleMultiCheckboxChange(field.key, option.field_value, e)}
            onClick={handleClick} onMouseOut={handleMouseOut}
        
        
        />
       <span onClick={handleClick} onMouseOut={handleMouseOut} style={{marginLeft:'7px'}}>  {`${option.field_text}${option.option_price ? ` (${option.option_price})` : ''}`}</span>
    </label>
))}
<div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
                                </div>
                                
                              </>  
                            )}
        {field._type === 'textarea' && (

         
                    
                    <>
<div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`}> 
    
    <div className='wc-block-components-text-input is-active'>
    <textarea  
        id={field.key} 
        placeholder={field._placeholder} 
        value={inputValues[field.key]} 
        onChange={handleTextareaInputChange} 
        onBlur={handleBlur}
        style={{
            backgroundColor:'#fff',
            border:'1px solid hsla(0,0%,7%,.8)',
            borderRadius:'4px',
            boxSizing:'border-box',
            color:'#2b2d2f',
            fontFamily:'inherit',
            fontSize:'1em',
            lineHeight:'1em',
            margin:'0',
            minHeight:'0',
            padding:'1.5em .5em .5em',
            width:'100%',

          }} 
    />
          <label for={field.key}>
                {`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}
           </label>
    </div>
     
    <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
    </div>
</>
                       
                    
          )}

{field._type === 'message' && (
<>
<div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`}> 
      <p id={field.key}>{field._text}</p>
</div>
</>
)}
{field._type === 'heading' && (
                             
 <>
 <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`}> 
 {field._heading_tag === 'h1' && (
    <div id={field.key} ><h1>{field._text}</h1></div>
 )}
 {field._heading_tag === 'h2' && (
 <div id={field.key} ><h1>{field._text}</h1></div>
 )}
 {field._heading_tag === 'h3' && (
 <div id={field.key} ><h2>{field._text}</h2></div>
 )}
 {field._heading_tag === 'h4' && (
 <div id={field.key} ><h4>{field._text}</h4></div>
 )}
 {field._heading_tag === 'h5' && (
 <div id={field.key} ><h5>{field._text}</h5></div>
 )}
 {field._heading_tag === 'h6' && (
 <div id={field.key} ><h6>{field._text}</h6></div>
 )}
   
 </div>
 </>
)}
     {field._type === 'checkbox' && (
                        <>
                        <div className={`${field._location_checkout_block}_block`}  id={`${field.key}_dependable`}> 
                         <label onClick={handleClick} onMouseOut={handleMouseOut}>
                         <input type='checkbox' 
                         id={field.key} 
                         className={field.key}
                         checked={inputValues[field.key]} 
                         onChange={handleCheckboxChange} 
                         onClick={handleClick}
                         onMouseOut={handleMouseOut}/>
                         <span onClick={handleClick} onMouseOut={handleMouseOut} style={{marginLeft:'7px'}}>{`${field.feild_title}${field.feild_price ? ` (${field.feild_price})` : ''}`}</span>
                          </label>
<div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
                        
                        </div>
                    </>
                    
                    )}
{field._type === 'radio' && (
            <>
            <div className={`${field._location_checkout_block}_block`} id={`${field.key}_dependable`}  > 
            <label>{field.feild_title}</label>
            {Object.entries(field._options).map(([key, option]) => (
                <label  style={{display:'block'}} htmlFor={`${field.key}_${key}`}>
                 <input type='radio'  
                 key={key} id={`${field.key}`} 
                 className={`${field.key}_${key}`} 
                 name={field.key} 
                 value={option.field_value} 
                 checked={inputValues[field.key] === option.field_value} 
                 onChange={handleRadioChange} 
                 onClick={handleClick} onMouseOut={handleMouseOut}
                 />
                 <span  style={{marginLeft:'7px'}}>{`${option.field_text}${option.option_price ? ` (${option.option_price})` : ''}`}</span></label>
            ))}
    <div className="wc-block-components-validation-error" style={{'display':'none'}}  id={`${field.key}_validation_error`} role="alert"><p>This feild is required</p></div>
            </div>
            </>
          )}
    </>)}
                </div>
            ))}
            <><div className='new-line'></div></>
            

        </div>
    );
    
};
